#![allow(deprecated)]
use std::fmt;
use std::str;
/// Specifies how areas of a plot should be shaded in relation to the defined threshold lines. Will eventually
/// include other shading configurations, like a buffer zone.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum ThresholdShadingConfig {
    #[serde(rename = "ABOVE")]
    Above,
    #[serde(rename = "BELOW")]
    Below,
    #[serde(rename = "NONE")]
    None,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl ThresholdShadingConfig {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            ThresholdShadingConfig::Above => "ABOVE",
            ThresholdShadingConfig::Below => "BELOW",
            ThresholdShadingConfig::None => "NONE",
            ThresholdShadingConfig::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for ThresholdShadingConfig {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for ThresholdShadingConfig {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for ThresholdShadingConfig {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<ThresholdShadingConfig, conjure_object::plain::ParseEnumError> {
        match v {
            "ABOVE" => Ok(ThresholdShadingConfig::Above),
            "BELOW" => Ok(ThresholdShadingConfig::Below),
            "NONE" => Ok(ThresholdShadingConfig::None),
            v => v.parse().map(|v| ThresholdShadingConfig::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for ThresholdShadingConfig {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<ThresholdShadingConfig, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the ThresholdShadingConfig enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
